---
title: CanvasRenderingContext2D.arc()
slug: Web/API/CanvasRenderingContext2D/arc
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.arc()</code></strong> method of the <a href="/en-US/docs/Web/API/CanvasRenderingContext2D">Canvas 2D API </a>adds a circular arc to the current sub-path.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.arc(<em>x</em>, <em>y</em>, <em>radius</em>, <em>startAngle</em>, <em>endAngle</em> [, <em>anticlockwise</em>]);
</pre>

<p>The <code>arc()</code> method creates a circular arc centered at <code>(x, y)</code> with a radius of<em> </em><code>radius</code>. The path starts at <code>startAngle</code>, ends at <code>endAngle</code>, and travels in the direction given by <code>anticlockwise</code> (defaulting to clockwise).</p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>The horizontal coordinate of the arc's center.</dd>
 <dt><code>y</code></dt>
 <dd>The vertical coordinate of the arc's center.</dd>
 <dt><code>radius</code></dt>
 <dd>The arc's radius. Must be positive.</dd>
 <dt><code>startAngle</code></dt>
 <dd>The angle at which the arc starts in radians, measured from the positive x-axis.</dd>
 <dt><code>endAngle</code></dt>
 <dd>The angle at which the arc ends in radians, measured from the positive x-axis.</dd>
 <dt><code>anticlockwise</code> {{optional_inline}}</dt>
 <dd>An optional {{jsxref("Boolean")}}. If <code>true</code>, draws the arc counter-clockwise between the start and end angles. The default is <code>false</code> (clockwise).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Drawing_a_full_circle">Drawing a full circle</h3>

<p>This example draws a complete circle with the <code>arc()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The arc is given an x-coordinate of 100, a y-coordinate of 75, and a radius of 50. To make a full circle, the arc begins at an angle of 0 radians (0<strong>°</strong>), and ends at an angle of 2π radians (360<strong>°</strong>).</p>

<pre class="brush: js; highlight:[5]">const canvas = document.querySelector('canvas');
const ctx = canvas.getContext('2d');

ctx.beginPath();
ctx.arc(100, 75, 50, 0, 2 * Math.PI);
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Drawing_a_full_circle', 700, 180) }}</p>

<h3 id="Different_shapes_demonstrated">Different shapes demonstrated</h3>

<p>This example draws various shapes to show what is possible with <code>arc()</code>.</p>

<div class="hidden">
<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas width="150" height="200"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>
</div>

<pre class="brush: js">const canvas = document.querySelector('canvas');
const ctx = canvas.getContext('2d');

// Draw shapes
for (let i = 0; i &lt;= 3; i++) {
  for (let j = 0; j &lt;= 2; j++) {
    ctx.beginPath();
    let x             = 25 + j * 50;                 // x coordinate
    let y             = 25 + i * 50;                 // y coordinate
    let radius        = 20;                          // Arc radius
    let startAngle    = 0;                           // Starting point on circle
    let endAngle      = Math.PI + (Math.PI * j) / 2; // End point on circle
    let anticlockwise = i % 2 == 1;                  // Draw anticlockwise

    ctx.arc(x, y, radius, startAngle, endAngle, anticlockwise);

    if (i &gt; 1) {
      ctx.fill();
    } else {
      ctx.stroke();
    }
  }
}</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Different_shapes_demonstrated', 160, 210, "https://mdn.mozillademos.org/files/204/Canvas_arc.png") }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-arc", "CanvasRenderingContext2D.arc")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.arc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>Use {{domxref("CanvasRenderingContext2D.ellipse()")}} to draw an elliptical arc.</li>
</ul>
